//   DirectoryNode.java --- Todo List

//   Copyright (C) 2003 Valvassori Mose <moise@valvassori.org>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.todolist;
import java.util.Date;
import java.util.ArrayList;

/**
 *
 * @author "Valvassori Mose" <moise@valvassori.org>
 * @version $Id: DirectoryNode.java,v 1.11 2003/02/11 16:43:39 djedi Exp $
 * @since Tue Feb  4 10:04:12 2003
 */
public class DirectoryNode {
  private int id;
  private String name;
  private int childCount = -1;
  private int type;
  private Date expir;
  private Date destruc;
  private ArrayList childs;
  private String annotation;
  private int annotationId;

  private static Object null_ = new Object();
  private static Date   nulldate = new Date(10000);

  public DirectoryNode(int i, String n, int type) {
    id = i;
    name = n;
    childs = new ArrayList();
    this.type = type;
  }

  public void set(Date exp,Date e) {
    if ((exp !=null) && nulldate.before(exp))
      expir = exp;

    if ((e != null) && nulldate.before(e))
      destruc = e;
  }

  public String toString(){
    return name;
  }
  public void setName(String n) {
    name = n;
  }

  public int getId() {
    return id;
  }
  public int getType() {
    return type;
  }

  public Date getExpiration() {
    return expir;
  }
  public Date getDestruction() {
    return destruc;
  }



  public Object getChild(int index) {
    Object n = childs.get(index);
    if (null_.equals(n)) {
      return null;
    }
    return n;
  }
  public void setChild(Object n, int index) {
    childs.set(index,n);
  }


  public void setChildCount(int n) {
    childCount = n;

    for (int i=childs.size(); i<n; i++) {
      childs.add(null_);
    }
  }
  public int getChildCount() {
    return childCount;
  }

  public int addChild(String name, int id,int type) {
    DirectoryNode n = new DirectoryNode(id,name,type);
    setChildCount(childCount+1);
    setChild(n,childCount-1);
    return childCount-1;
  }

  public int remove(DirectoryNode n) {
    for (int i=0; i<getChildCount(); i++) {
      if (n.equals(getChild(i))) {
	childs.remove(i);
	childCount--;
	return i;
      }
    }
    return 0;
  }

  public void setAnnotation(String a) {
    annotation = a;
  }
  public String getAnnotation() {
    return annotation;
  }
  public void setAnnotationId(int a) {
    annotationId = a;
  }
  public int getAnnotationId() {
    return annotationId;
  }
}
