//   Main.java --- TodoList

//   Copyright (C) 2003 Moise Valvassori <djedi@ai.univ-paris8.fr>

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.todolist;
import org.djedi.todolist.gui.MainFrame;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.File;
/**
 *
 * @author "Moise Valvassori" <djedi@ai.univ-paris8.fr>
 * @version 1.0
 * @since Mon Feb  3 15:18:36 2003
 */
public class Main {

  static Properties loadProperties() {
    Properties p = new Properties ();
    File f;

    // Properties dans le home
    try {
      f = new File (System.getProperty("user.home"),".todolist.properties");
      if (f.exists())
	p.load(new FileInputStream(f));
    } catch (IOException  e) {
      System.err.println("Error reading: "+new File (System.getProperty("user.home"),".todolist.properties"));
    }

    // Properties cach dans le rep courant.
    try {
      f = new File (System.getProperty("user.dir"),".todolist.properties");
      if (f.exists())
	p.load(new FileInputStream(f));
    } catch (IOException  e) {
      System.err.println("Error reading: "+new File (System.getProperty("user.dir"),"todolist.properties"));
    }
    // Properties dans le rep courant.
    try {
      f = new File (System.getProperty("user.dir"),"todolist.properties");
      if (f.exists())
	p.load(new FileInputStream(f));
    } catch (IOException  e) {
      System.err.println("Error reading: "+new File (System.getProperty("user.dir"),"todolist.properties"));
    }

    return p;
  }


  /**
   * Creates a new <code>Main</code> instance.
   *
   */
  public static void main (String arg[]) {
    Properties prop = loadProperties();

    DatabaseAccess dba = new DatabaseAccess(prop);
    new MainFrame(dba,prop).show();
  }
}
