/// LoginDialog.java --- Todo List

/// Copyright (C) 2003 Valvassori Mose <moise@valvassori.org>

/// This program is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// This program is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with this program; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package org.djedi.todolist.gui;

/**
 *
 * @author  djedi
 */
public class LoginDialog extends javax.swing.JDialog {

    /** Creates new form LoginDialog */
    public LoginDialog(java.awt.Frame parent, boolean modal,String name, String psswd) {
	super(parent, modal);
	initComponents();

	if ((name != null) && (!name.equals(""))) {
	  login.setText(name);
	  passwd.setText(psswd);
	  jButton1.setEnabled(false);
	}
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        login = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        passwd = new javax.swing.JPasswordField();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        jButton1.setText(java.util.ResourceBundle.getBundle("org/djedi/todolist/gui/gui").getString("New_User"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newuserEvent(evt);
            }
        });

        jPanel1.add(jButton1);

        jButton2.setText(java.util.ResourceBundle.getBundle("org/djedi/todolist/gui/gui").getString("Login"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginEvent(evt);
            }
        });

        jPanel1.add(jButton2);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.Y_AXIS));

        jLabel1.setText(java.util.ResourceBundle.getBundle("org/djedi/todolist/gui/gui").getString("Login:"));
        jPanel3.add(jLabel1);

        login.setColumns(16);
        jPanel3.add(login);

        jPanel2.add(jPanel3);

        jLabel2.setText(java.util.ResourceBundle.getBundle("org/djedi/todolist/gui/gui").getString("Password:"));
        jPanel4.add(jLabel2);

        passwd.setColumns(8);
        jPanel4.add(passwd);

        jPanel2.add(jPanel4);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void loginEvent(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loginEvent
	// Add your handling code here:
      if (((MainFrame)getParent()).getDatabaseAccess().login(login.getText(),passwd.getText())){
	((MainFrame)getParent()).logged();
	setVisible(false);
	dispose();

      } else {
	jButton1.setEnabled(true);
      }
    }//GEN-LAST:event_loginEvent

    private void newuserEvent(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newuserEvent
	// Add your handling code here:
      if (((MainFrame)getParent()).getDatabaseAccess().newUser(login.getText(),passwd.getText())){
	setVisible(false);
	dispose();
      }
    }//GEN-LAST:event_newuserEvent

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
	setVisible(false);
	dispose();
    }//GEN-LAST:event_closeDialog



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton1;
    private javax.swing.JPasswordField passwd;
    private javax.swing.JTextField login;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

}
